<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform version="1.0" 
	xmlns="http://www.w3.org/1999/xhtml" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:mml="http://www.w3.org/1998/Math/MathML">

<!--
Hermes document rendering stylesheet version 1.1.1, 2006-09-07.
License: GNU GPL
Author: Romeo Anghelache, http://romeo.roua.org
-->

<xsl:output method="xml" indent="yes" encoding="utf-8"/>

<xsl:template match="document">

<!--
<xsl:text disable-output-escaping="yes">
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1 plus MathML 2.0//EN" 
               "http://www.w3.org/Math/DTD/mathml2/xhtml-math11-f.dtd" &gt;
</xsl:text>
-->
<xsl:text disable-output-escaping="yes">
&lt;?xml-stylesheet type="text/xsl" href="mathml.xsl"?&gt;
</xsl:text>
<html>
	<head><xsl:text>
	</xsl:text>
		<title><xsl:value-of select="title"/>, 
		<xsl:for-each select="author">
		<xsl:value-of select="name"/>, 
		</xsl:for-each>
		<xsl:value-of select="date"/>
		</title>
		<meta content="text/xml; charset=utf-8" http-equiv="Content-Type" /><xsl:text>
		</xsl:text>
		<xsl:for-each select="author">
		<meta name="author">
		<xsl:attribute name="content">
		<xsl:choose>
		<xsl:when test="name">
			<xsl:value-of select="name"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="normalize-space(string(.))"/>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:attribute>
		</meta><xsl:text>
		</xsl:text>
		</xsl:for-each>
		<meta name="keywords">
		<xsl:attribute name="content">
		<xsl:value-of select="normalize-space(string(keywords))"/>
		</xsl:attribute>
		</meta><xsl:text>
		</xsl:text>
		<meta name="description">
		<xsl:attribute name="content">
		<xsl:value-of select="normalize-space(string(abstract))"/>
		</xsl:attribute>
		</meta><xsl:text>
		</xsl:text>
		<meta name="generator">
		<xsl:attribute name="content">
		<xsl:value-of select="concat(string(generator/name),
		', version ',string(generator/version),' ', string(generator/date),
		', license ',string(generator/license),
		', description ', string(generator/description))"/>
		</xsl:attribute>
		</meta><xsl:text>
		</xsl:text>
	<style type="text/css">
	a:link {text-decoration:none;}
	a:hover {text-decoration:none;background-color:lime;}
	a:visited {text-decoration:none;}
	
	h2,h3 {text-align:center;margin:0 5% 0 5%;}
	
	.abstract {margin:0 10% 0 10%;text-align:justify;}
 	.footnote {margin:0 0 0 5%;border-left:1px dashed blue;padding-left:1em;}
	.theorem,.definition,.lemma {margin:0 5% 0 5%;}
	

 	.title {color:maroon;font-weight:bolder;}
 	.break{margin-top:10px;}
	.label {color:green;font-weight:bolder;}
	.ftt {font-family: Courier, monospace, monospace;}
	.fbtt {font-weight:bolder;font-family: Courier, monospace, monospace;}
	.fttsl {color: maroon; font-family: Courier, monospace, monospace;}
	.fttsc {font-variant:small-caps;font-family: Courier, monospace, monospace;}
	.fi {color: maroon;}
	.fb {color: maroon;font-weight:bolder;}
	.fs {font-family:cursive;}
	.fss {font-family:sans-serif;}
	.fsc {font-variant:small-caps;}
	.fisc {color: maroon;font-variant:small-caps;}
	.fsssc {font-variant:small-caps;font-family:sans-serif;}
	.fsssl {color: maroon;font-family:sans-serif;}
	.fbsc {font-variant:small-caps;font-weight:bolder;}
	.fbi {color: maroon;font-weight:bolder;}
	.fbsl {font-style:oblique;font-weight:bolder;}
	.fbss {font-weight:bolder;font-family:sans-serif;}
	.fsl {color: maroon;}
	.fn {font-weight:normal;color:black;}
	.affiliation {text-align:center;margin:0 15% 0 15%;}

	
 	table {border-collapse: collapse;border: 1px solid gray;text-align:center;table-layout:fixed;width: 100%;}
 	
	table.math {border: none;text-align:center;table-layout:fixed;width: 100%;}
	table.math td {border: none;}
	
 	p.figure {border: 1px solid gray;}
 	div.img {text-align:center;border: 1px solid gray;}
 	caption, div.caption {border: 1px solid gray; text-align:left;width:100%;}
 	div.caption a span {text-decoration:none;color:red;}
 	
	td {border: 1px dotted gray;padding:10px; }
	ul {list-style-type:none;}
	
	</style>
	<script type="text/javascript">
	function toggleDisplay(id){
	fifi=document.getElementById(id);
	cucu=fifi.style.display;
	if (cucu=='none')
		fifi.style.display='block';
	else
		fifi.style.display='none';
	};
	</script>
	</head>
	<body style="text-align:justify;margin:0 15% 0 15%;">
	<xsl:text>
	</xsl:text>
	
	<xsl:apply-templates/>
<xsl:text>
</xsl:text>
</body>
</html>
</xsl:template>


<xsl:template match="mml:mtable/mml:mtr">
<table  class="math">
	<xsl:if test="@id">
	<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
	</xsl:if>
		<tr>
			<td align="left" width="90%">
				<math xmlns="http://www.w3.org/1998/Math/MathML" display="block">
					<mtable>
						<mtr>
							<xsl:apply-templates/>
						</mtr>
					</mtable>
				</math>
			</td>
			<td align="right" valign="top"/>
		</tr>
		</table>
</xsl:template>

<xsl:template match="mml:mtable/mml:mlabeledtr">
		<table class="math">
		<xsl:if test="@id">
		<xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute>
		</xsl:if>
		<tr>
			<td align="left" width="90%">
				<math xmlns="http://www.w3.org/1998/Math/MathML" display="block">
					<mtable>
						<mtr>
							<xsl:apply-templates select="mml:mtd[position()>1]"/>
						</mtr>
					</mtable>
				</math>
			</td>
			<td align="right" valign="top">
			<xsl:value-of select="mml:mtd[position()=1]"/>
			</td>
		</tr>
		</table>
</xsl:template>

<xsl:template match="mml:mtable"><xsl:apply-templates/></xsl:template>

<xsl:template match="mml:math">
<xsl:choose>
	<xsl:when test="mml:mtable"><xsl:apply-templates/></xsl:when>
	<xsl:otherwise>
		<math xmlns="http://www.w3.org/1998/Math/MathML">
			<xsl:if test="@display"><xsl:attribute name="display">block</xsl:attribute></xsl:if>
			<xsl:if test="@id"><xsl:attribute name="id"><xsl:value-of select="@id"/></xsl:attribute></xsl:if>
			<xsl:apply-templates/>
		</math><xsl:text> </xsl:text>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="env">
<p class="{@type}">
<xsl:if test="@id">
	<xsl:attribute name="id"><xsl:value-of select="@id"/>
</xsl:attribute></xsl:if>
</p>
<xsl:apply-templates/>
</xsl:template>
<xsl:template match="option"/>

<xsl:template match="*">
<xsl:copy-of select="."/>
</xsl:template>


<xsl:template match="cite">
<xsl:text>[</xsl:text>
<xsl:for-each select="sref">
<xsl:variable name="curRefNum" select="position()"/>
<a class="cref" href="#{.}">
<xsl:value-of select="../pref[$curRefNum]"/></a>
<xsl:if test='position()&lt;last()'><xsl:text>, </xsl:text></xsl:if>
</xsl:for-each>
<xsl:text>] </xsl:text>
</xsl:template>

<xsl:template match="ref">
<xsl:text> </xsl:text>
<a href="#{sref}">
<xsl:attribute name="href">#<xsl:value-of select="sref"/></xsl:attribute>
<xsl:value-of select="pref"/>
</a>
<xsl:text> </xsl:text>
</xsl:template>

<xsl:template match="float/option"/>
<xsl:template match="float[type='table'] | env[type='longtable']">
<table>
<xsl:if test="id">
<xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
</xsl:if>
<tr>
	<td>
		<xsl:apply-templates/>
	</td>
</tr>
</table>
</xsl:template>

<xsl:template match="tr">
<tr>
	<xsl:apply-templates/>
</tr>
</xsl:template>

<xsl:template match="td">
<td>
	<xsl:apply-templates/>
</td>
</xsl:template>

<xsl:template match="caption">
<caption>
	<xsl:apply-templates/>
</caption>
</xsl:template>


<xsl:template match="env">
<div>
<xsl:if test="id">
<xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
</xsl:if>
<xsl:apply-templates/>
</div>
</xsl:template>

<xsl:template match="tabular">
<table><xsl:apply-templates/>	</table>
</xsl:template>

<xsl:template match="tr">
<tr><xsl:apply-templates/></tr>
</xsl:template>

<xsl:template match="td">
<td><xsl:apply-templates/></td>
</xsl:template>

<xsl:template match="page"/>

<xsl:template match="author">
<h3>
<xsl:choose>
<xsl:when test="string-length(string(vaddress)) != 0">
<a>
<xsl:attribute name="href"><xsl:value-of select="vaddress"/></xsl:attribute>
	<xsl:value-of select="name"/>
</a>
</xsl:when>
<xsl:when test="string-length(string(email)) != 0">
<a>
<xsl:attribute name="href">mailto:<xsl:value-of select="email"/></xsl:attribute>
	<xsl:value-of select="name"/>
	</a>
</xsl:when>
<xsl:otherwise>
<xsl:choose>
<xsl:when test="name">
<xsl:value-of select="name"/>
</xsl:when>
<xsl:otherwise>
<xsl:value-of select="."/>
</xsl:otherwise>
</xsl:choose>

</xsl:otherwise>
</xsl:choose>
</h3>
<address><xsl:value-of select="affiliation"/></address>
</xsl:template>
<xsl:template match="date">
<h3><xsl:value-of select="."/></h3>
</xsl:template>
<xsl:template match="abstract">
<p class="abstract">
<xsl:apply-templates/>
</p>
</xsl:template>

<xsl:template match="footnote"/>

<xsl:template match="fnmark">
<sup><xsl:apply-templates/></sup>
</xsl:template>


<xsl:template match="subsection|subsubsection|section">
<p class="{type}">
<xsl:if test="id">
<xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
</xsl:if>
	<xsl:apply-templates/>
</p>
<xsl:for-each select="footnote">
		<p class="footnote"><xsl:apply-templates/></p>
</xsl:for-each>
</xsl:template>

<xsl:template match="bibliography">
<p class="bib"><xsl:apply-templates/></p>
</xsl:template>

<xsl:template match="section/title">
<xsl:apply-templates/>
<div class="break"/>
</xsl:template>

<xsl:template match="document/title">
<h2 class="title"><xsl:apply-templates/></h2>
</xsl:template>

<xsl:template match="type"/>
<xsl:template match="id"/>

<xsl:template match="bibliography/list/item/label"/>

<xsl:template match="label">
	<span class="{local-name(.)}">
		<xsl:apply-templates/>
	</span>
</xsl:template>

<xsl:template match="sref"/>

<xsl:template match="bibliography/list">
<ol class="{local-name(.)}">
<xsl:apply-templates/>
</ol>
</xsl:template>

<xsl:template match="list|description">
<ul class="{local-name(.)}">
<xsl:apply-templates/>
</ul>
</xsl:template>

<xsl:template match="item">
<li>
<xsl:if test="id">
<xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
</xsl:if>
<xsl:if test="label">
<xsl:attribute name="value"><xsl:value-of select="translate(string(label/ph),'[]','')"/></xsl:attribute>
</xsl:if>
<xsl:apply-templates/>
<xsl:if test="vaddress">
		 <a href="{vaddress}"><kbd>☻ open access ✓</kbd></a>
</xsl:if>
</li>
</xsl:template>
<xsl:template match="bibliography/list/item/vaddress"/>

<xsl:template match="head|foot">
<xsl:apply-templates/>
</xsl:template>

<xsl:template match="vaddress">
<a href="{text()}" >
<xsl:value-of select="."/>
</a>
</xsl:template>

<xsl:template match="br">
<div class="break"/>
</xsl:template>

<xsl:template match="ph">
<xsl:if test="string-length()">
<xsl:choose>
	<xsl:when test="contains(@f,'eccc')">
	<span class="fisc"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'ttsl')">
	<span class="fttsl"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'bsl')">
	<span class="fbsl"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'sssl')">
	<span class="fsssl"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'ttsc')">
	<span class="fttsc"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'bsc')">
	<span class="fbsc"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'sssc')">
	<span class="fsssc"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'sc')">
	<span class="fsc"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'bss')">
	<span class="fbss"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'ss')">
	<span class="fss"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'sl')">
	<span class="fsl"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'btt')">
	<span class="fbtt"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'tt')">
	<span class="ftt"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'bi')">
	<span class="fbi"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'b')">
	<span class="fb"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:when test="contains(@f,'i')">
	<span class="fi"><xsl:apply-templates/></span>
	</xsl:when>
	<xsl:otherwise>
	<span class="fn"><xsl:apply-templates/></span>
	</xsl:otherwise>
</xsl:choose>
</xsl:if>
</xsl:template>

<xsl:template match="float[type='figure']">
<p class="figure">
<xsl:if test="id">
<xsl:attribute name="id"><xsl:value-of select="id"/></xsl:attribute>
</xsl:if>
<xsl:variable name="figId"><xsl:value-of select="generate-id()"/></xsl:variable>
	<xsl:if test="caption">
	<div class="caption">
		<xsl:apply-templates select="caption" >
		<xsl:with-param name="figId" select="$figId"/>
		</xsl:apply-templates>
	</div>
	</xsl:if>
	<div id="{$figId}" class="img">
		<xsl:if test="not(caption)"><xsl:attribute name="style">display:block;</xsl:attribute></xsl:if>
		<xsl:if test="caption"><xsl:attribute name="style">display:none;</xsl:attribute></xsl:if>
		<img src="{concat(source/text(),'.png')}" alt="{source/text()}"/>
	</div>
</p>
</xsl:template>
<xsl:template match="float[type='figure']/caption">
<xsl:param name="figId"/>
	<xsl:apply-templates>
		<xsl:with-param name="figId" select="$figId"/>
	</xsl:apply-templates>
</xsl:template>
<xsl:template match="float[type='figure']/caption/label">
<xsl:param name="figId"/>
		<a href="javascript:toggleDisplay('{$figId}')">
		<xsl:attribute name="href">javascript:toggleDisplay('<xsl:value-of select="$figId"/>');</xsl:attribute>
		<xsl:apply-templates/>
		</a>
</xsl:template>

<xsl:template match="keywords"/>
<xsl:template match="generator"/>
</xsl:transform>
